#!/usr/bin/env python3
# tall.bot - a simple Discord Wikipedia bot
# Armaan Bhojwani 2020

import logging
import sys
import time
import wikipedia
import discord

def wiki_sum(search, sen, pid):
    try:
        logging.info(str(pid) + " | " + str(int(time.time())) + " | " + search)
        return "<Wikipedia> " + wikipedia.summary(search,
                                                  sentences=sen,
                                                  auto_suggest=False)
    except Exception as e:
        logging.debug(str(pid) + " | " + search + " | " + str(e))
        return str(e)

def create_query(inp):
    key1 = ["What", "what", "who", "Who"]
    key2 = ["is", "are", "were", "was"]
    key3 = ["a", "an", "the"]

    x = inp.split()
    if x[0] in key1 and x[1] in key2:
        x = x[2:]
        if x[0] in key3:
            x = x[1:]
    else:
        return False

    return " ".join(x)

class TallBot(discord.Client):
    async def on_ready(self):
        logging.info('Logged in as ', self.user)

    async def on_message(self, message):
        if message.author == self.user:
            return

        key = create_query(message.content)
        if key:
            await message.channel.send(wiki_sum(key, 2, message.author))

def main():
    TallBot().run(sys.argv[1])

if __name__ == "__main__":
    main()
